using System;
using System.Configuration;
using System.Net;
using System.Text;
using ITHit.WebDAV.Logger;

namespace WebDAVServer.Class2SqlListener
{
    internal class Program
    {
        private static void Main(string[] args)
        {
            string uriPrefix = ConfigurationManager.AppSettings["ListenerPrefix"];
            HttpListener listener = new HttpListener();
            listener.Prefixes.Add(uriPrefix);
            listener.Start();

            Console.WriteLine("Start listening on " + uriPrefix);
            Console.WriteLine("Press Control-C to stop listener...");

            FileLogger.Level = LogLevel.Debug;

            while (true)
            {
                IAsyncResult result = listener.BeginGetContext(new AsyncCallback(ListenerCallback), listener);
                result.AsyncWaitHandle.WaitOne();
            }
        }

        public static void ListenerCallback(IAsyncResult result)
        {
            HttpListener listener = (HttpListener) result.AsyncState;
            WDEngine engine = new WDEngine();
            HttpListenerContext context = listener.EndGetContext(result);
            WDRequest request = new WDRequest(context.Request, context.User);
            WDResponse response = new WDResponse(context.Response);

            engine.Run(request, response);

            if (response.StatusCode == 401)
            {
                byte[] message = new UTF8Encoding().GetBytes("Access denied");
                context.Response.OutputStream.Write(message, 0, message.Length);
            }

            try
            {
                context.Response.Close();
            }
            catch
            {
                // client closed connection before the content was sent
            }
        }
    }
}