﻿using System;
using System.Configuration;
using System.Net;
using ITHit.WebDAV.Logger;

namespace WebDAVServer.Listener
{
    class Program
    {
        static void Main(string[] args)
        {
            string uriPrefix = ConfigurationManager.AppSettings["ListenerPrefix"];
            HttpListener listener = new HttpListener();
            listener.Prefixes.Add(uriPrefix);
            listener.Start();

            Console.WriteLine("Start listening on " + uriPrefix);
            Console.WriteLine("Press Control-C to stop listener...");

            FileLogger.Level = LogLevel.Debug;

            while (true)
            {
                WDEngine engine = new WDEngine();
                HttpListenerContext context = listener.GetContext();
                WDRequest request = new WDRequest(context.Request, context.User);
                WDResponse response = new WDResponse(context.Response);
                engine.Run(request, response);
                try
                {
                    context.Response.Close();
                }
                catch
                {
                    // client closed connection before the content was sent
                }
            }
        }
    }
}
